<template>
  <q-item
    @click="goToPage"
    clickable
    v-ripple
    class="plot-preview"
  >
    <q-item-section
      avatar
      class="flex-center q-mr-md q-pr-none"
      style="min-width: 20px;"
    >
      <canvas
        v-if="plot.thumbnail"
        :id="plotCanvasId"
        style="max-width: 50px;"
      />
      <q-icon
        v-else
        class="text-grey"
        name="las la-draw-polygon"
        :style="`width: ${plotThumbnailSize}px;`"
      />
    </q-item-section>
    <q-item-section>
      <q-item-label
        lines="1"
        class="text-body2"
        style="max-width: 100%;"
      >
        {{ plot.name }}
      </q-item-label>
      <div
        class="row q-col-gutter-x-xs"
        style="max-width: 100%;"
      >
        <span
          v-if="plotPlantVarietyCanBeDisplayed"
          class="col ellipsis text-caption text-grey"
        >
          {{ plotCrop }}
        </span>
        <span
          v-if="plotAreaDisplay"
          class="col-auto text-grey"
        >
          {{ plotAreaDisplay }}
        </span>
      </div>
    </q-item-section>
    <q-item-section side>
      <q-icon name="las la-angle-right" />
    </q-item-section>
  </q-item>
</template>

<script>
import { getSortedPlotPlantVarieties } from 'src/services/plot/plotFormatting'
import featureFlags from 'src/services/feature-flags'
import { getI18nField } from 'src/services/translate'
import { formatSurface } from 'src/services/display-surface-unit'

export default {
  name: 'PlotPreviewListItem',
  props: {
    plot: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      plotThumbnailSize: 40,
      plotCanvg: null
    }
  },
  computed: {
    plotAreaDisplay () {
      if (this.plot && this.plot.area != null) {
        return formatSurface(this.plot.area)
      } else {
        return ''
      }
    },
    plotCrop () {
      if (this.plot.plot_plant_varieties && this.plot.plot_plant_varieties.length > 0) {
        const sortedPlotPlantVarieties = getSortedPlotPlantVarieties(this.plot.plot_plant_varieties)
        return sortedPlotPlantVarieties.map(plotPlantVariety => getI18nField(plotPlantVariety.plant_variety?.plant_species, 'name') || '').join(', ')
      } else {
        return ''
      }
    },
    plotCanvasId () {
      return `plot-${this.plot.id}-canvas-thumbnail`
    },
    plotPlantVarietyCanBeDisplayed () {
      return featureFlags.plotPlantVarietyCanBeDisplayed()
    }
  },
  methods: {
    goToPage () {
      this.$router.push({ name: 'plot', params: { idPlot: this.plot.id } })
    },
    displayPlotThumbnail (canvg) {
      if (this.plot.thumbnail) {
        const canvas = document.getElementById(this.plotCanvasId)
        // canvas maybe null after changing pages
        if (canvas) {
          const ctx = canvas.getContext('2d')
          const t = document.createElement('template')
          t.innerHTML = this.plot.thumbnail
          const svg = t.content.firstChild

          // Add some whitespace around the thumbnail
          let [x, y, width, height] = svg.getAttribute('viewBox').split(' ').map(Number)
          x -= width * 0.05
          y -= height * 0.05
          width *= 1.1
          height *= 1.1
          svg.setAttribute('viewBox', `${x} ${y} ${width} ${height}`)

          // Set the thumbnail style
          svg.setAttribute('fill', this.$store.state?.portalConfiguration?.mapOverlayStyles?.plot?.fill || '#000000')
          svg.setAttribute('fill-opacity', this.$store.state?.portalConfiguration?.mapOverlayStyles?.plot?.fillOpacity.toFixed(1) || '0.1')
          svg.setAttribute('stroke', this.$store.state?.portalConfiguration?.mapOverlayStyles?.plot?.color || '#000000')
          svg.setAttribute('stroke-width', '5%')
          this.plotCanvg = canvg.fromString(ctx, svg.outerHTML)
          this.plotCanvg.resize(this.plotThumbnailSize, this.plotThumbnailSize, 'xMidYMid meet')
          this.plotCanvg.render()
        }
      }
    },
    stopPlotCanvg () {
      if (this.plotCanvg) {
        this.plotCanvg.stop()
      }
    }
  },
  mounted () {
    // dynamically import Canvag to avoid bundling it with other vendor libs as it is quite large
    import('canvg').then(({ Canvg }) => { this.displayPlotThumbnail(Canvg) })
  },
  beforeUnmount () {
    this.stopPlotCanvg()
  }
}
</script>
